unit Unit2;

//Programm par Yoann
//http://delphipage.free.fr/

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Printers, ComCtrls;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    PrintDialog1: TPrintDialog;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    TrackBar2: TTrackBar;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { Dclarations prives }
    zoomh , zooml : integer;
    procedure Apercu;
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.Apercu;
var
  Rect: TRect;
begin
Rect.Top := 10;
Rect.Left := 10;
begin
Rect.Right := 10 +trunc(Form1.Image1.Picture.Graphic.Width *zooml) div 10;
Rect.Bottom := 10 +trunc(Form1.Image1.Picture.Graphic.Height *zoomh) div 10;
end;
Image1.Canvas.Pen.Mode := pmWhite;
Image1.Canvas.Rectangle (0, 0, Image1.Width, Image1.Height);
Image1.Canvas.StretchDraw (Rect,Form1.Image1.Picture.Graphic);
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
Close;
end;

procedure TForm2.FormActivate(Sender: TObject);
Var Tp,Lft:Word;
begin
//dimensionne l'image  pour tre au milieu de l'cran.
Image1.Width := Printer.PageWidth div 10;
Image1.Height := Printer.PageHeight div 10;
tp:=Round((Scrollbox1.Height-Image1.Height)/2);
Image1.Top:=tp;
Lft:=Round((Scrollbox1.Width-Image1.Width)/2);
Image1.Left:=Lft;
zooml:=4;
zoomh:=4;
//Appelle la procedure Apercu
Apercu;
end;

procedure TForm2.Button2Click(Sender: TObject);
Var
  Rect: TRect;
begin
if PrintDialog1.execute then
begin
//ferme la fiche avant l'impression
Close;
Rect.Top := 10;
Rect.Left := 10;
Rect.Right := 10 +trunc(Form1.Image1.Picture.Graphic.Width *zooml);
Rect.Bottom := 10 +trunc(Form1.Image1.Picture.Graphic.Height *zoomh);
//Commence l'impression
Printer.BeginDoc;
Printer.Canvas.StretchDraw (Rect,Form1.Image1.Picture.Graphic);
Printer.EndDoc;
//Fin de l'impression
end;
end;

procedure TForm2.TrackBar1Change(Sender: TObject);
begin
zoomh:=Form2.TrackBar1.Position;
Apercu;
end;

procedure TForm2.TrackBar2Change(Sender: TObject);
begin
zooml:=Form2.TrackBar2.Position;
Apercu;
end;

end.
